IF OBJECT_ID('TR__ActionGroupActions__ValidateSequence') IS NOT NULL DROP TRIGGER [TR__ActionGroupActions__ValidateSequence]
GO

CREATE TRIGGER [TR__ActionGroupActions__ValidateSequence]
       ON [ActionGroupActions] FOR INSERT, DELETE
AS 
BEGIN

	IF EXISTS(
			SELECT *
			  FROM [ActionGroupActions] AGA
				   INNER JOIN (SELECT [ActionGroup_Id], [Action_Sequence],
									  [Actual_Action_Sequence] = 
										   ROW_NUMBER() OVER (PARTITION BY [ActionGroup_Id]
										   ORDER BY [ActionGroup_Id], [Action_Sequence])
									  FROM [ActionGroupActions]) AGA_ACTUAL
						   ON AGA.[ActionGroup_Id] = AGA_ACTUAL.[ActionGroup_Id]
						  AND AGA.[Action_Sequence] = AGA_ACTUAL.[Action_Sequence]
			 WHERE AGA.[Action_Sequence] <> AGA_ACTUAL.[Actual_Action_Sequence]
			   AND ( 
			         EXISTS ( SELECT * FROM inserted
			                   WHERE AGA.[ActionGroup_Id] = [ActionGroup_Id])
					 OR 
			         EXISTS ( SELECT * FROM deleted
			                   WHERE AGA.[ActionGroup_Id] = [ActionGroup_Id])
				   )
		) 
	BEGIN

		RAISERROR('An invalid Action_Sequence was provided for the ActionGroup.', 16, 1)
		ROLLBACK

	END

END
GO