EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Builds_GetBuilds',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Builds_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the details for all builds that match the specified criteria.'
GO


IF OBJECT_ID('[Builds_GetBuilds]') IS NOT NULL DROP PROCEDURE [Builds_GetBuilds]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Builds_GetBuilds]
(
	@Application_Id INT,
	@Release_Number RELEASENUMBER = NULL,
	@BuildStatus_Name VARCHAR(8) = NULL,
	@Build_Count INT = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	IF (@Build_Count IS NOT NULL AND @Build_Count > 0)
	BEGIN
		SET ROWCOUNT @Build_Count
	END

	SELECT *
	  FROM [Builds_Extended]
	 WHERE (@Application_Id IS NULL OR [Application_Id] = @Application_Id)
	   AND (@Release_Number IS NULL OR [Release_Number] = @Release_Number)
	   AND (@BuildStatus_Name IS NULL OR [BuildStatus_Name] = @BuildStatus_Name)
	  ORDER BY [Release_Sequence] DESC, [Build_Sequence] DESC, [CreatedOn_Date] DESC

END
GO

GRANT EXECUTE ON [Builds_GetBuilds] TO [BuildMasterUser_Role]