EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Environments_GetEnvironment',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataSet',
    /* DataTableNames_Csv      */ 'Environments_Extended,Servers',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets an environment.'
GO


IF OBJECT_ID('[Environments_GetEnvironment]') IS NOT NULL DROP PROCEDURE [Environments_GetEnvironment]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Environments_GetEnvironment]
(
	@Environment_Id INT
)
AS
BEGIN

	SET NOCOUNT OFF 

	SELECT *
	  FROM [Environments_Extended]
     WHERE [Environment_Id] = @Environment_Id

	SELECT *
	  FROM [Servers]
	 WHERE [Server_Id] IN (SELECT [Server_Id] FROM [EnvironmentServers]
	                        WHERE [Environment_Id] = @Environment_Id)

END
GO

GRANT EXECUTE ON [Environments_GetEnvironment] TO [BuildMasterUser_Role]