EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'EventListeners_GetEventListener',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataSet',
    /* DataTableNames_Csv      */ 'EventListeners,EventListenerApplications,EventListenerApplicationGroups,EventListenerStages,EventListenerEvents',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets a EventListener and a list of event codes that the EventListener is subscribed to.'
GO

IF OBJECT_ID('[EventListeners_GetEventListener]') IS NOT NULL DROP PROCEDURE [EventListeners_GetEventListener]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [EventListeners_GetEventListener]
(
	@EventListener_Id INT
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT * FROM [EventListeners] WHERE [EventListener_Id] = @EventListener_Id
	SELECT * FROM [EventListenerApplications] WHERE [EventListener_Id] = @EventListener_Id
	SELECT * FROM [EventListenerApplicationGroups] WHERE [EventListener_Id] = @EventListener_Id
	SELECT * FROM [EventListenerStages] WHERE [EventListener_Id] = @EventListener_Id
	SELECT * FROM [EventListenerEvents] WHERE [EventListener_Id] = @EventListener_Id

END
GO

GRANT EXECUTE ON [EventListeners_GetEventListener] TO [BuildMasterUser_Role]