EXEC [__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Issues_GetIssueTypes',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Issues_Types',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets a list of distinct issue types that have been synchronized by the system.'
GO


IF OBJECT_ID('[Issues_GetIssueTypes]') IS NOT NULL DROP PROCEDURE [Issues_GetIssueTypes]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Issues_GetIssueTypes]
AS
BEGIN

	SET NOCOUNT ON

	SELECT * FROM [Issues_Types]
    ORDER BY [Type_Text]

END
GO

GRANT EXECUTE ON [Issues_GetIssueTypes] TO [BuildMasterUser_Role]
