EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Plans_GetDeploymentPlanActionGroup',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataSet',
    /* DataTableNames_Csv      */ 'DeploymentPlanActionGroups_Extended,ActionGroupActions_Extended,ActionGroupUsage_Slim,ApplicationDeploymentPlans',
    /* OutputPropertyNames_Csv */  NULL,
    /* Description_Text        */ 'Gets the details of the specified plan, and all the actions associated with the plan.'
GO


IF OBJECT_ID('[Plans_GetDeploymentPlanActionGroup]') IS NOT NULL DROP PROCEDURE [Plans_GetDeploymentPlanActionGroup]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Plans_GetDeploymentPlanActionGroup]
(
	@DeploymentPlanActionGroup_Id INT
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT *
	  FROM [DeploymentPlanActionGroups_Extended]
     WHERE [DeploymentPlanActionGroup_Id] = @DeploymentPlanActionGroup_Id
	
	DECLARE @ActionGroup_Id INT
	SET @ActionGroup_Id = (SELECT [ActionGroup_Id]
	                  FROM [DeploymentPlanActionGroups]
	                 WHERE [DeploymentPlanActionGroup_Id] = @DeploymentPlanActionGroup_Id)

	SELECT *
	  FROM [ActionGroupActions_Extended]
     WHERE [ActionGroup_Id] = @ActionGroup_Id
	 ORDER BY [Action_Sequence]

	SELECT *
	  FROM [ActionGroupUsage_Slim]
	 WHERE [ActionGroup_Id] = @ActionGroup_Id

	SELECT ADP.*
	  FROM [ApplicationDeploymentPlans] ADP
	       INNER JOIN [DeploymentPlanActionGroups_Extended] DPAG
	               ON ADP.[DeploymentPlan_Id] = DPAG.[DeploymentPlan_Id]
	 WHERE DPAG.[DeploymentPlanActionGroup_Id] = @DeploymentPlanActionGroup_Id

END
GO

GRANT EXECUTE ON [Plans_GetDeploymentPlanActionGroup] TO [BuildMasterUser_Role]
