EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Releases_DeleteReleaseNote',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Deletes a release note from the system.'
GO

IF OBJECT_ID('[Releases_DeleteReleaseNote]') IS NOT NULL DROP PROCEDURE [Releases_DeleteReleaseNote]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Releases_DeleteReleaseNote]
(
	@Release_Id INT,
	@ReleaseNote_Sequence INT
) 
AS BEGIN

	DELETE 
	  FROM [ReleaseNotes]
	 WHERE [Release_Id] = @Release_Id
	   AND [ReleaseNote_Sequence] = @ReleaseNote_Sequence

END
GO

GRANT EXECUTE ON [Releases_DeleteReleaseNote] TO [BuildMasterUser_Role]