EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Scripts_GetScript',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataSet',
    /* DataTableNames_Csv      */ 'Scripts_Extended,ScriptParameters,ScriptVariables',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets a script and all of its associated information.'
GO


IF OBJECT_ID('[Scripts_GetScript]') IS NOT NULL DROP PROCEDURE [Scripts_GetScript]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Scripts_GetScript]
(
	@Script_Id INT
)
AS
BEGIN

SET NOCOUNT ON

	SELECT *
	  FROM [Scripts_Extended]
	 WHERE [Script_Id] = @Script_Id

	SELECT *
	  FROM [ScriptParameters]
	 WHERE [Script_Id] = @Script_Id
	 ORDER BY [Parameter_Name]

	SELECT *
	  FROM [ScriptVariables]
	 WHERE [Script_Id] = @Script_Id
	 ORDER BY [ScriptVariable_Name]

END
GO

GRANT EXECUTE ON [Scripts_GetScript] TO [BuildMasterUser_Role]
