--EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
--    /* StoredProc_Name         */ 'Applications_CloneApplication',
--    /* Internal_Indicator      */ 'N',
--    /* ReturnType_Name         */ 'void',
--    /* DataTableNames_Csv      */ NULL,
--    /* OutputPropertyNames_Csv */ 'New_Application_Id',
--    /* Description_Text        */ 'Clones an application, but does not copy any history'
--GO

--IF OBJECT_ID('[Applications_CloneApplication]') IS NOT NULL
--	DROP PROCEDURE [Applications_CloneApplication]
--GO

--SET QUOTED_IDENTIFIER ON
--GO

--CREATE PROCEDURE [Applications_CloneApplication]
--(
--	@Application_Id INT,
--	@LinkAllActionGroups_Indicator YNINDICATOR = 'N',
--	@LinkAllDeploymentPlans_Indicator YNINDICATOR = 'N',
--	@New_Application_Name VARCHAR(50),
--	@New_Application_Id INT = NULL OUT
--) AS
--BEGIN


--SET NOCOUNT ON

--BEGIN TRY

--	BEGIN TRANSACTION

--	IF NOT EXISTS(SELECT * FROM [Applications] WHERE [Application_Id] = @Application_Id)
--		RAISERROR('Application %i does not exist.', 16, 1, @Application_Id)

--	IF @LinkAllActionGroups_Indicator = 'Y' AND @LinkAllDeploymentPlans_Indicator = 'Y'
--		RAISERROR('Cannot link action groups if deployment plans are linked.', 16, 1)

--	DECLARE @Application_Name VARCHAR(50)
--	SET @Application_Name = (SELECT [Application_Name] FROM [Applications] WHERE [Application_Id] = @Application_Id)

--	--==[Applications]==--
--	INSERT INTO [Applications] ([Application_Name], [ReleaseNumber_Scheme_Name],[BuildNumber_Scheme_Name],[IssueTracking_Provider_Id],[AllowMultipleActiveReleases_Indicator],[AllowMultipleActiveBuilds_Indicator],[ApplicationGroup_Id],[CreatedBy_User_Name],[CreatedOn_Date],[ModifiedBy_User_Name],[ModifiedOn_Date],[VariableSupport_Code], [IssueTracking_AllowBuildMasterIssues_Indicator], [AlwaysShowDeployables_Indicator])
--	SELECT @New_Application_Name, [ReleaseNumber_Scheme_Name],[BuildNumber_Scheme_Name],[IssueTracking_Provider_Id],[AllowMultipleActiveReleases_Indicator],[AllowMultipleActiveBuilds_Indicator],[ApplicationGroup_Id],dbo.Session_GetUserName(),GETUTCDATE(),dbo.Session_GetUserName(),GETUTCDATE(),[VariableSupport_Code], [IssueTracking_AllowBuildMasterIssues_Indicator], [AlwaysShowDeployables_Indicator]
--	  FROM [Applications]
--	 WHERE [Application_Id] = @Application_Id
--	SET @New_Application_Id = SCOPE_IDENTITY()

--	--==[Deployables]==--
--	INSERT INTO [Deployables] ([Application_Id],[Deployable_Name],[CreatedBy_User_Name],[CreatedOn_Date],[ModifiedBy_User_Name],[ModifiedOn_Date])
--	SELECT @New_Application_Id,[Deployable_Name],dbo.Session_GetUserName(),GETUTCDATE(),[ModifiedBy_User_Name],[ModifiedOn_Date]
--	 FROM [Deployables]
--	WHERE [Application_Id] = @Application_Id
	
--	--==[DeployableDependencies]==--
--	INSERT INTO [DeployableDependencies] ([Deployable_Id],[DependsOn_Deployable_Id])
--	SELECT D_NEW.[Deployable_Id],D2_NEW.[Deployable_Id]
--	  FROM [DeployableDependencies] DD
--	       INNER JOIN [Deployables] D
--	               ON D.[Deployable_Id] = DD.[Deployable_Id]
--	       INNER JOIN [Deployables] D2
--	               ON D2.[Deployable_Id] = DD.[DependsOn_Deployable_Id]
--	       INNER JOIN [Deployables] D_NEW
--	               ON D_NEW.[Deployable_Name] = D.[Deployable_Name]
--	              AND D_NEW.[Application_Id] = @New_Application_Id
--	       INNER JOIN [Deployables] D2_NEW
--	               ON D2_NEW.[Deployable_Name] = D2.[Deployable_Name]
--	              AND D2_NEW.[Application_Id] = @New_Application_Id
--	 WHERE D.[Application_Id] = @Application_Id

--	--==[DeployablesImported]==--
--	INSERT INTO [DeployablesImported]([Deployable_Id],[Application_Id])
--	SELECT [Deployable_Id], @New_Application_Id
--	  FROM [DeployablesImported]
--	 WHERE [Application_Id] = @Application_Id


--     --==[Workflows]==--

--     DECLARE @AppWorkflows TABLE ([Workflow_Id] INT NOT NULL, [Workflow_Name] VARCHAR(MAX))
--      INSERT @AppWorkflows ([Workflow_Id], [Workflow_Name]) 
--      SELECT W.[Workflow_Id], W.[Workflow_Name] 
--        FROM [ApplicationWorkflows] AW
--  INNER JOIN [Workflows] W ON W.[Workflow_Id] = AW.[Workflow_Id]
--       WHERE AW.[Application_Id] = @Application_Id
--         AND W.[Global_Indicator] = 'N'

--     DECLARE @NewWorkflowIdsCsv VARCHAR(MAX)
--     DECLARE @CloneDeploymentPlans_Indicator YNINDICATOR
--     DECLARE @WorkflowCloneData_Xml VARCHAR(MAX)
--     DECLARE @Workflow_Id INT
--     DECLARE @Workflow_Name NVARCHAR(50)
     
--     SET @CloneDeploymentPlans_Indicator = CASE WHEN @LinkAllDeploymentPlans_Indicator = 'Y' THEN 'N' ELSE 'Y' END
     
--     SET @WorkflowCloneData_Xml = '<WorkflowCloneData CloneDeploymentPlans_Indicator="' + @CloneDeploymentPlans_Indicator + '" LinkAllActionGroups_Indicator="' + @LinkAllActionGroups_Indicator + '">'

--     WHILE EXISTS(SELECT * FROM @AppWorkflows)
--     BEGIN

--        SELECT TOP 1 @Workflow_Id = [Workflow_Id], @Workflow_Name = [Workflow_Name] FROM @AppWorkflows
     
--         SET @WorkflowCloneData_Xml = @WorkflowCloneData_Xml + 
--            '<Workflow>
--                <New_Workflow_Name>' + @Workflow_Name + '</New_Workflow_Name>
--                <Workflow_Id>' + CAST(@Workflow_Id AS VARCHAR(MAX)) + '</Workflow_Id>
--                <New_Application_Id>' + CAST(@New_Application_Id AS VARCHAR(MAX)) + '</New_Application_Id>
--            </Workflow>'

--        DELETE @AppWorkflows WHERE [Workflow_Id] = @Workflow_Id

--     END
     
--     SET @WorkflowCloneData_Xml =  @WorkflowCloneData_Xml + '</WorkflowCloneData>'
	  
--     EXEC [Workflows_CloneWorkflow] @WorkflowCloneData_Xml, @NewWorkflowIdsCsv 
	
--	/* Set-up Release */
--	DECLARE @New_Workflow_Id INT
--    DECLARE @New_Workflow_Name VARCHAR(MAX)
--	   SELECT TOP 1 @New_Workflow_Id = W.[Workflow_Id], @New_Workflow_Name = [Workflow_Name] 
--         FROM [ApplicationWorkflows] AW
--   INNER JOIN [Workflows] W ON W.[Workflow_Id] = AW.[Workflow_Id]
--        WHERE [Application_Id] = @New_Application_Id
	
--	DECLARE @New_Release_Number RELEASENUMBER
--	SELECT @New_Release_Number = CASE [ReleaseNumber_Scheme_Name]
--	         WHEN 'MajorMinorRevision' THEN '0.0.0'
--	         WHEN 'MajorMinor' THEN '0.0'
--	         WHEN 'DateBased' THEN '0' END
--	  FROM [Applications]
--	 WHERE [Application_Id] = @New_Application_Id
	 
--	IF @New_Workflow_Id IS NOT NULL
--		INSERT INTO [Releases]([Application_Id],[Release_Number],[Workflow_Id],[ReleaseStatus_Name],[Notes_Text],[Target_Date],[Release_Name],[CreatedBy_User_Name],[CreatedOn_Date],[ModifiedBy_User_Name],[ModifiedOn_Date],[CancelledBy_User_Name],[CancelledReason_Text],[CancelledOn_Date],[Release_Sequence],[Original_Workflow_Name])
--		VALUES (@New_Application_Id,@New_Release_Number,@New_Workflow_Id,'Active',NULL,NULL,'Setup',dbo.Session_GetUserName(),GETUTCDATE(),dbo.Session_GetUserName(),GETUTCDATE(),NULL,NULL,NULL, 1, @New_Workflow_Name)

--    IF @New_Workflow_Id IS NOT NULL
--        INSERT [ReleaseDeployables] ([Application_Id], [Release_Number], [Deployable_Id], [InclusionType_Code])
--        SELECT @New_Application_Id, @New_Release_Number, [Deployable_Id], 'I' FROM [Deployables] WHERE [Application_Id] = @New_Application_Id
    

--	--==[VariableDeclarations]==--
--	PRINT 'VariableDeclarations...'
--    INSERT INTO [VariableDeclarations] 
--    (
--		[Scope_Code],
--		[Variable_Name],
--		[Scoped_Application_Id],
--		[Scoped_Environment_Id],
--		[Required_Indicator],
--		[Variable_Configuration],
--		[DefaultValue_Text],
--		[CreatedBy_User_Name],
--		[CreatedOn_Date],
--		[Sensitive_Indicator]
--	)
--    SELECT [Scope_Code],
--		   [Variable_Name],
--		   @New_Application_Id,
--		   [Scoped_Environment_Id],
--		   [Required_Indicator],
--		   [Variable_Configuration],
--		   [DefaultValue_Text],
--		   dbo.Session_GetUserName(),
--		   GETUTCDATE(),
--		   [Sensitive_Indicator]
--     FROM [VariableDeclarations] 
--	WHERE [Scoped_Application_Id] = @Application_Id

--    --==[VariableDefinitions: Deployable Variables]==--
--    PRINT 'VariableDefinitions: Deployable variables...'
--    INSERT INTO [VariableDefinitions]
--    (
--         [Variable_Name]
--        ,[Environment_Id]
--        ,[Server_Id]
--        ,[ApplicationGroup_Id]
--        ,[Application_Id]
--        ,[Deployable_Id]
--        ,[Release_Number]
--        ,[Build_Number]
--        ,[Value_Text]
--        ,[Execution_Id]
--        ,[Sensitive_Indicator]
--    )
--    SELECT 
--         [Variable_Name]
--        ,[Environment_Id]
--        ,[Server_Id]
--        ,[ApplicationGroup_Id]
--        ,VD.[Application_Id]
--        ,D_NEW.[Deployable_Id]
--        ,[Release_Number]
--        ,[Build_Number]
--        ,[Value_Text]
--        ,[Execution_Id]
--        ,[Sensitive_Indicator]
--    FROM [VariableDefinitions] VD
--      INNER JOIN [Deployables] D
--              ON D.[Deployable_Id] = VD.[Deployable_Id]
--      INNER JOIN [Deployables] D_NEW WITH (READUNCOMMITTED)
--              ON D_NEW.[Application_Id] = @New_Application_Id
--             AND D_NEW.[Deployable_Name] = D.[Deployable_Name]
--   WHERE D.[Application_Id] = @Application_Id
--     AND VD.[Scope_Code] = 'D'

--   --==[VariableDefinitions: Application Variables]==--
--    PRINT 'VariableDefinitions: Application variables...'
--    INSERT INTO [VariableDefinitions]
--    (
--         [Variable_Name]
--        ,[Environment_Id]
--        ,[Server_Id]
--        ,[ApplicationGroup_Id]
--        ,[Application_Id]
--        ,[Deployable_Id]
--        ,[Release_Number]
--        ,[Build_Number]
--        ,[Value_Text]
--        ,[Execution_Id]
--        ,[Sensitive_Indicator]
--    )
--    SELECT 
--         [Variable_Name]
--        ,[Environment_Id]
--        ,[Server_Id]
--        ,[ApplicationGroup_Id]
--        ,@New_Application_Id
--        ,[Deployable_Id]
--        ,[Release_Number]
--        ,[Build_Number]
--        ,[Value_Text]
--        ,[Execution_Id]
--        ,[Sensitive_Indicator]
--    FROM [VariableDefinitions] VD
--   WHERE VD.[Application_Id] = @Application_Id
--     AND VD.[Scope_Code] = 'A'

--	--==[BuildSchedules]==--
--	PRINT 'BuildSchedules...'
--	INSERT INTO [BuildSchedules] ([Schedule_Name],[Application_Id],[Active_Indicator],[CreatedBy_User_Name],[CreatedOn_Date],[ModifiedBy_User_Name],[ModifiedOn_Date],[Schedule_Type],[StartTime_Minutes],[EndTime_Minutes],[DailyInterval_Minutes],[Recurrence_Type],[RecurrenceFrequency_Value],[RecurrenceWeeklyDay_Mask],[RecurrenceMonthlyDay_Value],[RecurrenceMonthlyRelativity_Type],[RecurrenceMonthlyRelativityDay_Type],[RecurrenceMonthlyRelativityWeek_Type],[RecurrenceMonthlyRelativityWeekDay_Value],[Url_AllowedIP_CSV],[Url_Username_Text],[Url_Password_Text],[SourceControl_Path_Name],[SourceControl_Provider_Id],[SourceControl_QuietPeriod_Minutes],[ReleaseFilter_ReleaseType_Code])
--	SELECT [Schedule_Name],@New_Application_Id,[Active_Indicator],dbo.Session_GetUserName(),GETUTCDATE(),[ModifiedBy_User_Name],[ModifiedOn_Date],[Schedule_Type],[StartTime_Minutes],[EndTime_Minutes],[DailyInterval_Minutes],[Recurrence_Type],[RecurrenceFrequency_Value],[RecurrenceWeeklyDay_Mask],[RecurrenceMonthlyDay_Value],[RecurrenceMonthlyRelativity_Type],[RecurrenceMonthlyRelativityDay_Type],[RecurrenceMonthlyRelativityWeek_Type],[RecurrenceMonthlyRelativityWeekDay_Value],[Url_AllowedIP_CSV],[Url_Username_Text],[Url_Password_Text],[SourceControl_Path_Name],[SourceControl_Provider_Id],[SourceControl_QuietPeriod_Minutes],[ReleaseFilter_ReleaseType_Code]
--	  FROM [BuildSchedules]
--	 WHERE [Application_Id] = @Application_Id
      
--   --==[BuildScheduleVariableDefinitions]==--
--   PRINT 'BuildScheduleVariableDefinitions...'
--	INSERT INTO [BuildScheduleVariableDefinitions]([Schedule_Id],[VariableDeclaration_Id],[Value_Text])
--	 SELECT BS_NEW.[Schedule_Id], VD_NEW.[VariableDeclaration_Id],BSVD.[Value_Text]
--	   FROM [BuildSchedules] BS
--	        INNER JOIN [BuildScheduleVariableDefinitions] BSVD
--	                ON BSVD.[Schedule_Id] = BS.[Schedule_Id]
--	        INNER JOIN [VariableDeclarations] VD
--	                ON BSVD.[VariableDeclaration_Id] = VD.[VariableDeclaration_Id]
--	        INNER JOIN [BuildSchedules] BS_NEW
--	                ON BS_NEW.[Schedule_Name] = BS.[Schedule_Name]
--	               AND BS_NEW.[Application_Id] = @New_Application_Id
--            INNER JOIN [VariableDeclarations] VD_NEW
--                    ON VD_NEW.[Scoped_Application_Id] = VD.[Scoped_Application_Id]
--                   AND VD_NEW.[Scope_Code] = VD.[Scope_Code]
--                   AND VD_NEW.[Variable_Name] = VD.[Variable_Name]
--	  WHERE BS.[Application_Id] = @Application_Id

--	--==[Privileges]==--
--	INSERT INTO [Privileges]([Principal_Name],[PrincipalType_Code],[Role_Id],[Application_Id],[Environment_Id],[PrivilegeType_Code],[UserDirectory_Id],[ApplicationGroup_Id])
--	SELECT [Principal_Name],[PrincipalType_Code],[Role_Id],@New_Application_Id,[Environment_Id],[PrivilegeType_Code],[UserDirectory_Id],[ApplicationGroup_Id]
--	  FROM [Privileges]
--	 WHERE [Application_Id] = @Application_Id

	
--	INSERT INTO [ConfigurationFiles]([Deployable_Id],[FilePath_Text],[Active_Indicator],[CreatedBy_User_Name],[CreatedOn_Date],[ModifiedBy_User_Name],[ModifiedOn_Date])
--	SELECT D_NEW.[Deployable_Id],[FilePath_Text],[Active_Indicator],dbo.Session_GetUserName(),GETUTCDATE(),CF.[ModifiedBy_User_Name],CF.[ModifiedOn_Date]
--	  FROM [ConfigurationFiles] CF
--	       INNER JOIN [Deployables] D
--			       ON D.[Deployable_Id] = CF.[Deployable_Id]
--	       INNER JOIN [Deployables] D_NEW
--	               ON D_NEW.[Deployable_Name] = D.[Deployable_Name]
--	              AND D_NEW.[Application_Id] = @New_Application_Id
--	 WHERE CF.[Active_Indicator] = 'Y'
--	   AND D.[Application_Id] = @Application_Id
--	   AND @New_Release_Number IS NOT NULL

--	INSERT INTO [ConfigurationFileInstances]([ConfigurationFile_Id],[Instance_Name],[Active_Indicator],[Environment_Id],[Template_Indicator],[Template_Instance_Name],[TransformType_Code])
--	SELECT CF_NEW.[ConfigurationFile_Id],[Instance_Name],'Y',[Environment_Id],[Template_Indicator],[Template_Instance_Name],[TransformType_Code]
--	  FROM [ConfigurationFileInstances] CFI
--	       INNER JOIN [ConfigurationFiles] CF
--	               ON CF.[ConfigurationFile_Id] = CFI.[ConfigurationFile_Id]
--	       INNER JOIN [Deployables] D
--			       ON D.[Deployable_Id] = CF.[Deployable_Id]
--	       INNER JOIN [Deployables] D_NEW
--	               ON D_NEW.[Deployable_Name] = D.[Deployable_Name]
--	              AND D_NEW.[Application_Id] = @New_Application_Id			       
--	       INNER JOIN [ConfigurationFiles] CF_NEW
--	               ON CF_NEW.[FilePath_Text] = CF.[FilePath_Text]
--	              AND CF_NEW.[Deployable_Id] = D_NEW.[Deployable_Id]
--	 WHERE CFI.[Active_Indicator] = 'Y'
--	   AND D.[Application_Id] = @Application_Id


--	INSERT INTO [ConfigurationFileVersions]
--	(
--		[ConfigurationFile_Id],
--		[Instance_Name],
--		[Version_Number],
--		[VersionNotes_Text],
--		[File_Date],
--		[File_Bytes],
--		[CreatedBy_User_Name],
--		[CreatedOn_Date]
--	)
--	SELECT CF_NEW.[ConfigurationFile_Id],
--	       CFV.[Instance_Name],
--		   1,
--		   CASE WHEN [File_Bytes] IS NULL THEN NULL ELSE 'Cloned from ' + @Application_Name END,
--		   CASE WHEN [File_Bytes] IS NULL THEN NULL ELSE GETUTCDATE() END,
--		   [File_Bytes],
--		   CASE WHEN [File_Bytes] IS NULL THEN NULL ELSE dbo.Session_GetUserName() END,
--		   CASE WHEN [File_Bytes] IS NULL THEN NULL ELSE GETUTCDATE() END
--	  FROM [ConfigurationFileVersions_Extended] CFV
--		   INNER JOIN (SELECT [ConfigurationFile_Id],[Instance_Name],[Max_Version_Number] = MAX([Version_Number])
--						 FROM [ConfigurationFileVersions_Extended]
--						GROUP BY [ConfigurationFile_Id],[Instance_Name]) CFVMAX
--				   ON CFVMAX.[ConfigurationFile_Id] = CFV.[ConfigurationFile_Id]
--				  AND CFVMAX.[Instance_Name] = CFV.[Instance_Name]
--				  AND CFVMAX.[Max_Version_Number] = CFV.[Version_Number]
--			   INNER JOIN [ConfigurationFileInstances] CFI
--					   ON CFI.[ConfigurationFile_Id] = CFV.[ConfigurationFile_Id]
--					  AND CFI.[Instance_Name] = CFV.[Instance_Name]
--			   INNER JOIN [ConfigurationFiles] CF
--					   ON CF.[ConfigurationFile_Id] = CFI.[ConfigurationFile_Id]
--			   INNER JOIN [Deployables] D
--					   ON D.[Deployable_Id] = CF.[Deployable_Id]
--			   INNER JOIN [Deployables] D_NEW
--					   ON D_NEW.[Deployable_Name] = D.[Deployable_Name]
--					  AND D_NEW.[Application_Id] = @New_Application_Id			       
--			   INNER JOIN [ConfigurationFiles] CF_NEW
--					   ON CF_NEW.[FilePath_Text] = CF.[FilePath_Text]
--					  AND CF_NEW.[Deployable_Id] = D_NEW.[Deployable_Id]
--			   INNER JOIN [ConfigurationFileInstances] CFI_NEW
--					   ON CFI_NEW.[ConfigurationFile_Id] = CF_NEW.[ConfigurationFile_Id]
--					  AND CFI_NEW.[Instance_Name] = CFI.[Instance_Name]
--	 WHERE D.[Application_Id] = @Application_Id
	
--	/* Database Providers aren't cloned */
--	UPDATE [ActionGroupActions]
--	   SET [Active_Indicator] = 'N'
--	  FROM [ActionGroupActions] AGA
--	       INNER JOIN [ActionGroups] AG 
--		           ON AG.[ActionGroup_Id] = AGA.[ActionGroup_Id]
--	       INNER JOIN [DeploymentPlanActionGroups] DPAG
--		           ON DPAG.[ActionGroup_Id] = AG.[ActionGroup_Id]
--           INNER JOIN [ApplicationDeploymentPlans] ADP
--		           ON ADP.[DeploymentPlan_Id] = DPAG.[DeploymentPlan_Id]
--	 WHERE CAST([Action_Configuration].query('local-name(/*[1])') AS NVARCHAR(MAX)) LIKE 'Inedo.BuildMaster.Extensibility.Actions.Database%'		           
--	   AND ADP.[Application_Id] = @New_Application_Id
--	   AND @LinkAllActionGroups_Indicator = 'N'
--	   AND @LinkAllDeploymentPlans_Indicator = 'N'


--	/* Raise Event */
--	EXEC [Events_RaiseEvent] 'APPNEW', @New_Application_Id


--	COMMIT
--END TRY BEGIN CATCH
--	IF XACT_STATE()<>0 ROLLBACK
--	EXEC [HandleError]
--END CATCH

--END
--GO

--GRANT EXECUTE ON [Applications_CloneApplication] TO [BuildMasterUser_Role]
--GO
